image: golang:1.17

stages:
  - build
  - test
  - release

build:
  stage: build
  script:
    - go build ./...

test:
  stage: test
  script:
    - test -z "$(gofmt -l . | tee /dev/stderr)"
    - go test -cover ./...
    - curl -sfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(go env GOPATH)/bin v1.43.0
    - golangci-lint run -v

release:
  stage: release
  rules:
    - if: '$CI_COMMIT_TAG != null'
  script:
    - ./release.sh
